| Flutter Impeller |

Public Member Functions | List of all members
impeller::SuperellipseGeometry Class Referencefinal

`#include <superellipse_geometry.h>`

Inheritance diagram for impeller::SuperellipseGeometry:

## Public Member Functions
| SuperellipseGeometry (const Point &center, Scalar radius, Scalar degree, Scalar alpha, Scalar beta)
| ~SuperellipseGeometry () override
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const
virtual Scalar | ComputeAlphaCoverage (const Matrix &transform) const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const flutter::DlPath &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const flutter::DlPath &path, const StrokeParameters &stroke={})
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeFilledArc (const Rect &oval_bounds, Degrees start, Degrees sweep, bool include_center)
static std::unique_ptr< Geometry > | MakeStrokedArc (const Rect &oval_bounds, Degrees start, Degrees sweep, const StrokeParameters &stroke)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakeRoundSuperellipse (const Rect &rect, Scalar corner_radius)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

Geometry class that can generate vertices for a superellipse.

A Superellipse is an ellipse-like shape that is defined by the parameters N, alpha, and beta:

1 = |x / b| ^n + |y / a| ^n

The radius and center apply a uniform scaling and offset that is separate from alpha or beta. When n = 4, the shape is referred to as a rectellipse.

See also: https://en.wikipedia.org/wiki/Superellipse

Definition at line 23 of file superellipse_geometry.h.

## Constructor & Destructor Documentation

## ◆ SuperellipseGeometry()

impeller::SuperellipseGeometry::SuperellipseGeometry | ( | const Point & | center,
|  | Scalar | radius,
|  | Scalar | degree,
|  | Scalar | alpha,
|  | Scalar | beta
| ) |  |
| explicit

Definition at line 13 of file superellipse_geometry.cc.

18 : center_(center),
19 degree_(degree),
20 radius_(radius),
21 alpha_(alpha),
22 beta_(beta) {}

## ◆ ~SuperellipseGeometry()

impeller::SuperellipseGeometry::~SuperellipseGeometry | ( |  | ) |
| override

Definition at line 24 of file superellipse_geometry.cc.

24 {}

## Member Function Documentation

## ◆ CoversArea()

bool impeller::SuperellipseGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| overridevirtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 105 of file superellipse_geometry.cc.

106 {
107 return false;
108 }

## ◆ IsAxisAlignedRect()

bool impeller::SuperellipseGeometry::IsAxisAlignedRect | ( |  | ) | const
| overridevirtual

Reimplemented from impeller::Geometry.

Definition at line 110 of file superellipse_geometry.cc.

110 {
111 return false;
112 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/superellipse_geometry.h
- impeller/entity/geometry/superellipse_geometry.cc